//+------------------------------------------------------------------+
//|                                                  s-ReConnect.mq4 |
//|                                          Copyright  2009, Talex |
//|                                      talex.kaliningrad@gmail.com |
//+------------------------------------------------------------------+
//
// !!!
//       "",  
#property copyright "Copyright  2009, Talex"
#property link      "talex.kaliningrad@gmail.com"
#import "user32.dll"
   int GetAncestor (int hWnd, int gaFlags);
   int GetDlgItem (int hDlg, int nIDDlgItem);
   int GetLastActivePopup (int hWndOwner);
   int PostMessageA (int hWnd, int Msg, int wParam, int lParam);
#import
#define WM_COMMAND         0x0111
#define WM_KEYDOWN         0x0100
#define VK_HOME            0x24
#define VK_ENTER           0x0D

int Pause=15000;                                    //  15 
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start() {
   bool flag=true;
//------------------------------------
   while(!IsStopped()) {
      Comment("ReConnect");
      if(!flag) {
         Print(" .  : ",TimeToStr(TimeCurrent()));
         Comment("ReConnect\n .\n : ",TimeToStr(TimeCurrent()));
         flag=true;
      }
      while(!IsConnected()&&!IsStopped()) {         //   
         if(flag) {
            Print("   .  : ",TimeToStr(TimeCurrent()));
            Comment("ReConnect\n   .\n : ",TimeToStr(TimeCurrent()));
            flag=false;
         }
         Rescan();                                  //  
         Sleep(Pause);                              //  
         if(!IsConnected()) {                       //   
            Reconnect();                            //  
            Sleep(Pause);                           //  
         }
      }
      Sleep(60000);
   }
   Comment("");
   return;
}
//+------------------------------------------------------------------+
//-----------------------------------------------------------------------+
//                                 +
//-----------------------------------------------------------------------+
void Rescan() {
   int hwindow=GetAncestor(WindowHandle(Symbol(),Period()),2);//    
//-----------------------------------
   Comment("ReConnect\n... ");
	if(hwindow!=0) {                                 //   
	   PostMessageA(hwindow,WM_COMMAND,37400,0);     //   " " 
	}
	else Print("Rescan Error:",GetLastError());
	return;
}
//-----------------------------------------------------------------------+
//-----------------------------------------------------------------------+
//                                 +
//-----------------------------------------------------------------------+
void Reconnect() {
   int hwindow=WindowHandle(Symbol(),Period()),     //    
       hterminal=GetAncestor(hwindow,2);            //    
//---------------------------- 
   Comment("ReConnect\n... ");
   if(hterminal!=0) {                               //   
      hwindow=GetDlgItem(hterminal,0xE81C);
      hwindow=GetDlgItem(hwindow,0x52);
      hwindow=GetDlgItem(hwindow,0x8A70);           //    
      PostMessageA(hwindow,WM_KEYDOWN,VK_HOME,0);   //      
      PostMessageA(hwindow,WM_KEYDOWN,VK_ENTER,0);  //  
      Sleep(1000);                                  // 
      hwindow=GetLastActivePopup(hterminal);        //   
      PostMessageA(hwindow,WM_KEYDOWN,VK_ENTER,0);  // 
   }
   else Print("Reconnect Error:",GetLastError());
   return;
}
//-----------------------------------------------------------------------+